<template>
  <gp-collapsible-toolbar :persistent="entries.persistent"
                          :items="entries.visible"
                          :hidden="entries.hidden"
                          :breakpoint="breakpoint"
                          right>
    <template #help>
      <rui-help-button-content :caption="$t('js.garden.elements.actions.help.caption')" :content="$t('js.garden.elements.actions.help.content')" :lines="helpLines" />
    </template>
  </gp-collapsible-toolbar>
</template>

<script>
import { markRaw } from 'vue'
import { handledBreakpoints } from '../../../../plugins/Breakpoints'
import Element from '../../../../classes/models/Element'

import Toaster from '../../../../tools/Toaster'

import RuiHelpButtonContent from '@experiments-labs/rise_ui/src/components/HelpButton/HelpButtonContent.vue'

import GpCollapsibleToolbar from '../../../../common/CollapsibleToolbar/CollapsibleToolbar.vue'
import GpaElementDestroyWarning from './_DestroyWarning.vue'

const RawDestroyWarning = markRaw(GpaElementDestroyWarning)

const actionsContexts = {
  default: {
    persistent: ['addObservation', 'showObservations', 'separator', 'addTask', 'separator'],
    hidden: ['implant', 'remove', 'separator', 'harvests', 'separator', 'move', 'separator', 'duplicateElement', 'editElement', 'destroyElement'],
  },
  inventory: {
    visible: ['implant', 'remove', 'separator', 'duplicateElement', 'separator'],
    hidden: ['editElement', 'destroyElement'],
  },
  list: {
    persistent: ['addObservation', 'separator', 'addTask', 'separator', 'harvests', 'separator'],
    hidden: ['showObservations', 'separator', 'implant', 'remove', 'separator', 'move', 'separator', 'duplicateElement', 'editElement', 'destroyElement'],
  },
}

export const availableContexts = Object.keys(actionsContexts)

export default {
  name: 'GpaElementActions',
  components: { RuiHelpButtonContent, GpCollapsibleToolbar },
  props: {
    element: { required: true, type: Element },
    context: { required: false, type: String, default: 'default', validator: v => availableContexts.includes(v) },
    breakpoint: { required: false, type: String, default: 'small', validator: (v) => handledBreakpoints.includes(v) },
  },
  data () {
    const helpLines = []
    helpLines.push({ icon: 'arrow-bend-right-down', text: this.$t('js.garden.elements.actions.help.implant') })
    helpLines.push({ icon: 'arrow-bend-right-up', text: this.$t('js.garden.elements.actions.help.remove') })
    helpLines.push({ icon: 'observations', text: this.$t('js.garden.elements.actions.help.new_observation') })
    helpLines.push({ icon: 'calendar-plus', text: this.$t('js.garden.elements.actions.help.new_task') })
    helpLines.push({ icon: 'notebook', text: this.$t('js.garden.elements.actions.help.show_observation') })

    if (!this.element.patchId) {
      helpLines.push({ icon: 'arrows-out-cardinal', text: this.$t('js.garden.elements.actions.help.move') })
    }
    helpLines.push({ icon: 'pencil', text: this.$t('js.garden.elements.actions.help.edit') })
    helpLines.push({ icon: 'duplicate', text: this.$t('js.garden.elements.actions.help.duplicate') })
    helpLines.push({ icon: 'harvest', text: this.$t('js.garden.elements.actions.help.harvests') })
    helpLines.push({ icon: 'trash', text: this.$t('js.garden.elements.actions.help.trash'), variant: 'danger' })

    return {
      helpLines,
    }
  },
  computed: {
    actions () {
      return {
        move: {
          caption: this.$t('js.generic.move'),
          onclick: () => {
            this.$emitBus('move-element', this.element)
          },
          icon: 'arrows-out-cardinal',
          variant: 'canceling',
          condition: () => !this.element.isRemoved,
        },
        addObservation: {
          caption: this.$t('js.elements.action_buttons.add_observation'),
          onclick: () => {
            this.$emitBus('show-observation-form', this.element)
          },
          icon: 'observations',
          condition: () => !this.element.isRemoved,
        },
        showObservations: {
          caption: this.$t('js.elements.action_buttons.show_observations'),
          disabled: this.element.observationsCount === 0,
          onclick: () => {
            this.$emitBus('show-observations', this.element)
          },
          icon: 'notebook',
        },
        addTask: {
          caption: this.$t('js.elements.action_buttons.add_task'),
          onclick: () => {
            this.$emitBus('show-task-form', this.element)
          },
          icon: 'calendar-plus',
          condition: () => !this.element.isRemoved,
        },
        harvests: {
          caption: this.$t('js.elements.action_buttons.harvests'),
          onclick: () => {
            this.$emitBus('show-harvests', this.element)
          },
          icon: 'harvest',
          condition: () => !this.element.isRemoved,
        },
        editElement: {
          caption: this.$t('js.elements.action_buttons.edit_element'),
          onclick: () => {
            this.$emitBus('show-element-form', this.element)
          },
          icon: 'pencil',
        },
        duplicateElement: {
          caption: this.$t('js.elements.action_buttons.duplicate'),
          onclick: () => {
            this.duplicate()
          },
          icon: 'duplicate',
        },
        destroyElement: {
          caption: this.$t('js.elements.action_buttons.destroy_element'),
          onclick: () => {
            this.destroy()
          },
          icon: 'trash',
          variant: 'destructive',
        },
        implant: {
          caption: this.$t('js.elements.action_buttons.implant'),
          onclick: () => {
            this.$emitBus('show-implantation-form', this.element)
          },
          icon: 'arrow-bend-right-down',
          variant: 'creative',
          condition: () => !this.element.isRemoved && !this.element.isImplanted && !this.element.isImplantationPlanned,
        },
        remove: {
          caption: this.$t('js.elements.action_buttons.remove'),
          onclick: () => {
            this.$emitBus('show-removal-form', this.element)
          },
          icon: 'arrow-bend-right-up',
          variant: 'canceling',
          condition: () => !this.element.isRemoved && this.element.implantedAt && !this.element.isRemovalPlanned,
        },
      }
    },
    entries () {
      const list = { visible: [], hidden: [], persistent: [] }
      Object.keys(actionsContexts[this.context]).forEach((visibility) => {
        actionsContexts[this.context][visibility].forEach((entry) => {
          // Avoid two consecutive separators
          if (entry === 'separator' && list[visibility][list[visibility].length - 1] === 'separator') return
          if (this.actions[entry]?.condition && !this.actions[entry].condition()) return

          list[visibility].push(entry === 'separator' ? 'separator' : this.actions[entry])
        })
      })

      return list
    },
  },
  methods: {
    destroy () {
      this.$emitBus('ask-confirmation', {
        caption: this.$t('js.element.destroy_warning_title'),
        component: RawDestroyWarning,
        callback: () => {
          this.$store.dispatch('destroyElement', this.element.id)
            .then(() => {
              Toaster.success(this.$t('js.element.successfully_destroyed'))
            })
            .catch(() => {
              Toaster.error(this.$t('js.element.failed_to_destroy'))
            })
        },
      })
    },
    duplicate () {
      this.$store.dispatch('duplicateElement', this.element.id)
        .then(() => {
          Toaster.success(this.$t('js.element.successfully_duplicated'))
        })
        .catch(() => {
          Toaster.error(this.$t('js.element.failed_to_duplicate'))
        })
    },
  },
}
</script>
